﻿using ElectricLocomotive;
using ProjectElectricLocomotive.DrawingObjects;
using ProjectElectricLocomotive.Generics;
using ProjectElectricLocomotive.MovementStrategy;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;


namespace ProjectElectricLocomotive
{
    public partial class FormLocomotiveCollections : Form
    {
        private readonly LocomotiveGenericCollection<DrawingLocomotive, DrawingObjectLocomotive> _locomotives;
        public FormLocomotiveCollections()
        {
            InitializeComponent();
            _locomotives = new LocomotiveGenericCollection<DrawingLocomotive, DrawingObjectLocomotive>(pictureBoxCollections.Width,
                pictureBoxCollections.Height);
        }

        private void ButtonAddLocomotive_Click(object sender, EventArgs e)
        {
            if (_locomotives == null) return;
            FormElectricLocomotive form = new();
            if (form.ShowDialog() == DialogResult.OK)
            {
                //проверяем, удалось ли нам загрузить объект
                if (_locomotives + form.SelectedLocomotive != -1)
                {
                    MessageBox.Show("Объект добавлен");
                    pictureBoxCollections.Image = _locomotives.ShowLocomotives();
                }
                else
                {
                    MessageBox.Show("Не удалось добавить объект");
                }
            }
        }

        private void ButtonRemoveLocomotive_Click(object sender, EventArgs e)
        {
            if (MessageBox.Show("Удалить объект?", "Удаление", MessageBoxButtons.YesNo, MessageBoxIcon.Question) == DialogResult.No)
            {
                return;
            }
            int pos = Convert.ToInt32(maskedTextBoxNumber.Text);
            if (_locomotives - pos != null)
            {
                MessageBox.Show("Объект удален");
                pictureBoxCollections.Image = _locomotives.ShowLocomotives();
            }
            else
            {
                MessageBox.Show("Не удалось удалить объект");
            }
        }

        private void ButtonRefreshCollection_Click(object sender, EventArgs e)
        {
            pictureBoxCollections.Image = _locomotives.ShowLocomotives();
        }
    }
}
